<?php
/*
Plugin Name: hellotrust
Description: hellotrust ermöglicht Ihnen datenschutzkonformes und personalisiertes Marketing mit dynamischem Cookie-Hinweis sowie dynamischer Datenschutzerklärung.
Version: 1.0.6
Author: hellotrust.de ist ein Produkt der Keyed GmbH
Author URI: http://www.hellotrust.de
Plugin URI: http://www.hellotrust.de
License: MIT License
License URI: http://opensource.org/licenses/MIT
Text Domain: hellotrust
Domain Path: /languages
*/

// exit if accessed directly
if (!defined('ABSPATH'))
    exit;

define('HT_PLUGIN_VERSION', '1.0.6');
//define('HT_API_SERVER', 'http://localhost:3000/api/');
define('HT_API_SERVER', 'https://api.hellotrust.de/api/');
define('HT_PLUGIN_UPDATE_SERVER', 'https://update.hellotrust.de/wordpress');
define('HT_CURRENT_LANGUAGE', 'later...');

include_once "includes/functions.php";

$keyed_cookie = new hellotrust();

class hellotrust
{

    /**
     * @var $defaults
     */
    //private $positions = array();
    //private $styles = array();
    //private $choices = array();
    //private $links = array();
    //private $link_target = array();
    //private $colors = array();
    private $options = array();
    //private $effects = array();
    //private $times = array();
    //private $script_placements = array();
    private $current_language = '';
    /**
     * Constructor.
     */
    public function __construct()
    {
        $this->defaults = array(
            'general' => array(
                'api_key' => '',
                'deactivate_cookie_box' => '',
                'deactivate_content_blocker' => '',
                'activate_hellotrust_logged_in' => 'no',
                'popup_headline_de_DE' => __('Wir verwenden Cookies', 'hellotrust'),
                'popup_headline_en_US' => __('We use cookies', 'hellotrust'),
                'popup_headline_nl_NL' => __('Wij gebruiken cookies', 'hellotrust'),
                'popup_headline_fr_FR' => __('Nous utilisons des cookies', 'hellotrust'),
                'popup_headline_it_IT' => __('Utilizziamo i cookie', 'hellotrust'),
                'popup_headline_es_ES' => __('Usamos cookies', 'hellotrust'),
                'popup_headline_ru_RU' => __('Мы используем файлы cookie', 'hellotrust'),
                'popup_intro_de_DE' => __('Wir nutzen Cookies auf unserer Website. Einige von ihnen sind essenziell, während andere uns helfen, diese Website und Ihre Erfahrung zu verbessern.', 'hellotrust'),
                'popup_intro_en_US' => __('We use cookies on our website. Some of them are essential while others help us to improve this website and your experience.', 'hellotrust'),
                'popup_intro_nl_NL' => __('We gebruiken cookies op onze website. Sommige zijn essentieel, terwijl andere ons helpen deze website en uw ervaring te verbeteren.', 'hellotrust'),
                'popup_intro_fr_FR' => __('Nous utilisons des cookies sur notre site web. Certaines d\'entre elles sont essentielles, tandis que d\'autres nous aident à améliorer ce site web et votre expérience.', 'hellotrust'),
                'popup_intro_it_IT' => __('Sul nostro sito web utilizziamo i cookie. Alcuni di essi sono essenziali, mentre altri ci aiutano a migliorare questo sito web e la vostra esperienza.', 'hellotrust'),
                'popup_intro_es_ES' => __('Usamos cookies en nuestro sitio web. Algunos de ellos son esenciales, mientras que otros nos ayudan a mejorar este sitio web y su experiencia.', 'hellotrust'),
                'popup_intro_ru_RU' => __('Мы используем файлы cookie на нашем сайте. Некоторые из них являются основными, другие помогают нам улучшить этот сайт и ваши впечатления.', 'hellotrust'),
                'accept_text_de_DE' => __('Alle akzeptieren', 'hellotrust'),
                'accept_text_en_US' => __('All accept', 'hellotrust'),
                'accept_text_nl_NL' => __('Iedereen accepteert', 'hellotrust'),
                'accept_text_fr_FR' => __('Accepter tout', 'hellotrust'),
                'accept_text_it_IT' => __('Accetta tutti', 'hellotrust'),
                'accept_text_es_ES' => __('Acepta todo', 'hellotrust'),
                'accept_text_ru_RU' => __('Все принимают', 'hellotrust'),
                'only_checked_text_de_DE' => __('Auswahl speichern', 'hellotrust'),
                'only_checked_text_en_US' => __('Save selection', 'hellotrust'),
                'only_checked_text_nl_NL' => __('Selectie opslaan', 'hellotrust'),
                'only_checked_text_fr_FR' => __('Sauvegarder la sélection', 'hellotrust'),
                'only_checked_text_it_IT' => __('Salva la selezione', 'hellotrust'),
                'only_checked_text_es_ES' => __('Guardar la selección', 'hellotrust'),
                'only_checked_text_ru_RU' => __('Сохранить выбор', 'hellotrust'),
                'individual_cookies_text_de_DE' => __('Individuelle Cookie-Einstellungen', 'hellotrust'),
                'individual_cookies_text_en_US' => __('Individual cookie settings', 'hellotrust'),
                'individual_cookies_text_nl_NL' => __('Individuele cookie-instellingen', 'hellotrust'),
                'individual_cookies_text_fr_FR' => __('Paramètres individuels des cookies', 'hellotrust'),
                'individual_cookies_text_it_IT' => __('Impostazioni individuali dei cookie', 'hellotrust'),
                'individual_cookies_text_es_ES' => __('Configuraciones de cookies individuales', 'hellotrust'),
                'individual_cookies_text_ru_RU' => __('Индивидуальные настройки cookie', 'hellotrust'),
                'only_necessary_text_de_DE' => __('Nur notwendige Cookies akzeptieren', 'hellotrust'),
                'only_necessary_text_en_US' => __('Only accept necessary cookies', 'hellotrust'),
                'only_necessary_text_nl_NL' => __('Accepteer alleen noodzakelijke cookies', 'hellotrust'),
                'only_necessary_text_fr_FR' => __('N\'accepter que les cookies nécessaires', 'hellotrust'),
                'only_necessary_text_it_IT' => __('Accettare solo i cookie necessari', 'hellotrust'),
                'only_necessary_text_es_ES' => __('Sólo acepte las cookies necesarias', 'hellotrust'),
                'only_necessary_text_ru_RU' => __('Принимать только необходимые файлы cookie', 'hellotrust'),
                'history_text_de_DE' => __('Historie einsehen', 'hellotrust'),
                'history_text_en_US' => __('See history', 'hellotrust'),
                'history_text_nl_NL' => __('Zie geschiedenis', 'hellotrust'),
                'history_text_fr_FR' => __('Voir l\'historique', 'hellotrust'),
                'history_text_it_IT' => __('Visualizza la storia', 'hellotrust'),
                'history_text_es_ES' => __('Ver la historia', 'hellotrust'),
                'history_text_ru_RU' => __('Посмотреть историю', 'hellotrust'),
                'affiliate_text' => __('Auch du möchtest deine Webseite Datenschutzkonform darstellen? Dann nutze <a href="https://hellotrust.de/?affiliate_id=1234">hellotrust auch auf deiner Webseite - hier klicken</a>.', 'hellotrust'),
                'link_privacy_police' => '',
                'link_privacy_police_de_DE' => '',
                'link_privacy_police_en_US' => '',
                'link_privacy_police_nl_NL' => '',
                'link_privacy_police_fr_FR' => '',
                'link_privacy_police_it_IT' => '',
                'link_privacy_police_es_ES' => '',
                'link_privacy_police_ru_RU' => '',
                'link_imprint' => '',
                'link_imprint_de_DE' => '',
                'link_imprint_en_US' => '',
                'link_imprint_nl_NL' => '',
                'link_imprint_fr_FR' => '',
                'link_imprint_it_IT' => '',
                'link_imprint_es_ES' => '',
                'link_imprint_ru_RU' => '',
                'popup_background_color' => '#ffffff',
                'text_color' => '#000',
                'highlight_color' => '#0808de',
                'highlight_text_color' => '#fff',
                'second_highlight_color' => '#0808de',
                'fixed_link_cookie_popup_icon_or_text' => '',
                'hide_row_version_and_info' => ''
            ),
            'languages' => array(
                __('Deutsch', 'hellotrust') => 'de_DE',
                __('Englisch', 'hellotrust') => 'en_US',
                __('Niederländisch', 'hellotrust') => 'nl_NL',
                __('Französisch', 'hellotrust') => 'fr_FR',
                __('Italienisch', 'hellotrust') => 'it_IT',
                __('Spanisch', 'hellotrust') => 'es_ES',
                __('Russisch', 'hellotrust') => 'ru_RU'
            ),
            'version' => HT_PLUGIN_VERSION
        );

        $this->options = array(
            'general' => array_merge($this->defaults['general'], get_option('hellotrust_options', $this->defaults['general']))
        );

        if ($this->options['general']['api_key'] == "") {
            add_action('admin_notices', array($this, 'notice_no_api_key'));
        } else {
            if (!get_option('hellotrust_cookies_used')) {
                add_action('admin_notices', array($this, 'notice_no_cookies'));
            }
        }

        $this->current_language = HT_CURRENT_LANGUAGE;

        $this->fallback_language = 'en_US';

        // actions
        add_action('wp', array($this, 'site_current_language'));
        add_action('init', array($this, 'register_shortcode'));
        add_action('init', array($this, 'register_custom_post_type_cookies'));
        //add_action('init', array($this, 'register_wp_super_cache_cookies') );
        add_action('admin_init', array($this, 'register_settings'));
        add_action('admin_menu', array($this, 'admin_menu_options'));
        add_action('plugins_loaded', array($this, 'load_textdomain'));
        add_action('admin_enqueue_scripts', array($this, 'admin_enqueue_scripts'));
        add_action('wp_enqueue_scripts', array($this, 'frontend_style_and_scripts'));

        if ($this->options['general']['deactivate_cookie_box'] != 'yes') {
            add_action('wp_footer', array($this, 'frontend_add_cookie_popup'), 1000);
            add_action('wp_head', array($this, 'frontend_attach_scripts'), 1000);
            // content blocker
            if ($this->options['general']['deactivate_content_blocker'] != 'yes') {
                add_action('wp_head', array($this, 'buffer_start'));
                add_action('wp_footer', array($this, 'buffer_end'));
            }
        }
        // ajax
        add_action('wp_ajax_nopriv_hellotrust_cookies_accept', array($this, 'ajax_cookies_accept'));
        add_action('wp_ajax_hellotrust_cookies_accept', array($this, 'ajax_cookies_accept'));
        add_action('wp_ajax_hellotrust_get_history', array($this, 'ajax_get_history'));
        add_action('wp_ajax_nopriv_hellotrust_get_history', array($this, 'ajax_get_history'));

        // admin columns
        add_filter('manage_hellotrust-cookies_posts_columns', array($this, 'admin_manage_columns'), 10, 1);
        add_action('manage_hellotrust-cookies_posts_custom_column', array($this, 'admin_manage_custom_columns'), 10, 2);

        // exclude from search by yoast seo
        add_filter('wpseo_sitemap_exclude_taxonomy', array($this, 'sitemap_exclude_taxonomy'), 10, 2);
        add_filter('wpseo_sitemap_exclude_post_type', array($this, 'sitemap_exclude_post_type'), 10, 2);

        register_activation_hook(__FILE__, array($this, 'activation'));
        //register_deactivation_hook(__FILE__, array($this, 'deactivation'));

        // load other files
        include_once(plugin_dir_path(__FILE__) . 'includes/functions.php');

        $this->credits = '<div class="credits">
					<h3 class="hndle" style="font-weight:300">
					<img src="' . plugins_url('assets/fingerprint.svg', __FILE__) . '" style="    width: 21px;margin-right: 4px;margin-bottom: -7px;" />
					' . __('hellotrust - <strong>we</strong>protect. <strong>you</strong>decide.', 'hellotrust') . ' — Version ' . $this->defaults['version'] . '</h3>
					<div class="inside">
						<hr />
						<p class="df-link inner">' . __('<a href="https://hellotrust.de/?utm_source=hellotrust-settings&utm_medium=link&utm_campaign=created-by">hellotrust</a> ist ein Produkt der <a href="https://keyed.de/?utm_source=hellotrust-settings&utm_medium=link&utm_campaign=created-by" target="_blank">Keyed GmbH</a>', 'hellotrust') . '</p>
					</div>
				</div>';

        add_action('hellotrust_hourly_event', array($this, 'hellotrust_hourly_event'));
        wp_schedule_single_event(current_time('timestamp') + 3600, 'hellotrust_hourly_event');
    }

    public function activation()
    {
        wp_insert_term(__('Notwendig', 'hellotrust'), 'hellotrust-cookies-category');
        wp_insert_term(__('Präferenzen', 'hellotrust'), 'hellotrust-cookies-category');
        wp_insert_term(__('Statistiken', 'hellotrust'), 'hellotrust-cookies-category');
        wp_insert_term(__('Marketing', 'hellotrust'), 'hellotrust-cookies-category');

        if (!wp_next_scheduled('hellotrust_hourly_event')) {
            wp_schedule_event(current_time('timestamp'), 'hourly', 'hellotrust_hourly_event');
        }
    }

    public function register_shortcode()
    {
        //add_shortcode( 'hellotrust_cookies_used', array( $this, 'shortcode_cookies_used' ) );
        //add_shortcode( 'hellotrust_cookies_accepted', array( $this, 'shortcode_cookies_accepted' ) );
        add_shortcode('hellotrust_privacy_policy', array($this, 'shortcode_privacy_policy'));
        //add_shortcode( 'hellotrust_history', array( $this, 'shortcode_history' ) );
        add_shortcode('hellotrust_content_blocker', array($this, 'shortcode_content_blocker'));
    }

    /*public function register_wp_super_cache_cookies() {
        do_action( 'wpsc_add_cookie', 'hellotrust_categories_accepted' );
        do_action( 'wpsc_add_cookie', 'hellotrust_cookies_accepted' );
        do_action( 'wpsc_add_cookie', 'hellotrust_history' );
    }*/

    public function load_textdomain()
    {
        load_plugin_textdomain('hellotrust', false, dirname(plugin_basename(__FILE__)) . '/languages/');
    }

    public function site_current_language()
    {
        if (function_exists('pll_current_language')) {
            $wp_lang = pll_current_language('locale');
        } else {
            $wp_lang = get_locale();
        }

        if ($wp_lang == 'de_DE_formal') {
            $this->current_language = 'de_DE';
        } elseif ($wp_lang == 'en_GB' or $wp_lang == 'en') {
            $this->current_language = 'en_US';
        } else {
            $this->current_language = $wp_lang;
        }
    }

    public function checkStringTranslated($translated_string, $fallback_string)
    {
        if (trim($translated_string) != "") {
            return $translated_string;
        } else {
            return $fallback_string;
        }
    }

    public function language_api($language)
    {
        // no more necessary
        if ($language == 'de_DE' || $language == 'de_DE_formal') {
            return 'de_DE';
        } elseif ($language == 'en_US' || $language == 'en_GB' || $language == 'en_EN') {
            return 'en_GB';
        } else {
            return $language;
        }
    }

    public function admin_enqueue_scripts()
    {
        // Css rules for Color Picker
        wp_enqueue_style('wp-color-picker');
        wp_enqueue_style('hellotrust_backend.css', plugins_url('admin/hellotrust_backend.css', __FILE__), NULL, $this->defaults['version']);
        wp_enqueue_script('hellotrust_backend', plugins_url('admin/hellotrust_backend.js', __FILE__), array('jquery', 'wp-color-picker'), $this->defaults['version'], true);
    }

    public function admin_manage_columns($columns)
    {
        $columns = array();
        $columns['hellotrust-cookie-id'] = __('Cookie-ID', 'hellotrust');
        $columns['title'] = __('Cookie-Name', 'hellotrust');
        $columns['vendor'] = __('Anbieter', 'hellotrust');
        $columns['category'] = __('Kategorie', 'hellotrust');

        return $columns;
    }

    public function admin_manage_custom_columns($column, $post_id)
    {
        switch ($column) {
            case 'hellotrust-cookie-id':
                echo get_the_ID($post_id);
                break;
            case 'title':
                echo get_the_title($post_id);
                break;
            case 'vendor':
                echo get_field('vendor');
                break;
            case 'category':
                $terms = get_the_term_list($post_id, 'hellotrust-cookies-category', '', ',', '');
                if (is_string($terms))
                    echo $terms;
                else
                    _e('Unable to get name(s)', 'hellotrust');
                break;
        }
    }

    public function register_custom_post_type_cookies()
    {
        $labels = array(
            'name'                    => __('hellotrust', 'hellotrust'),
            'all_items'             => __('Drittanbieter Scripts', 'hellotrust'),
            'singular_name'            => __('Script', 'hellotrust'),
            'add_new'                => __('Script - Hinzufügen', 'hellotrust'),
            'add_new_item'            => __('Neues Script hinzufügen', 'hellotrust'),
            'edit_item'                => __('Script bearbeiten', 'hellotrust'),
            'new_item'                => __('Neues Script', 'hellotrust'),
            'view_item'                => __('Scripts ansehen', 'hellotrust'),
            'search_items'            => __('Suche nach Scripts', 'hellotrust'),
            'not_found'                => __('Nichts gefunden', 'hellotrust'),
            'not_found_in_trash'    => __('Nichts gefunden im Papierkorb', 'hellotrust'),
            'parent_item_colon'        => ''
        );
        $args = array(
            'labels'                => $labels,
            'public'                => false,
            'publicly_queryable'    => false,
            'exclude_from_search'    => true,
            'show_ui'                => true,
            'show_in_nav_menus'        => false,
            'has_archive'            => false,
            'query_var'                => true,
            'rewrite'                => false,
            'menu_icon'                => plugins_url('assets/fingerprint.svg', __FILE__),
            'capabilities' => array(
                'publish_posts' => 'manage_options',
                'edit_posts' => 'manage_options',
                'edit_others_posts' => 'manage_options',
                'delete_posts' => 'manage_options',
                'delete_others_posts' => 'manage_options',
                'read_private_posts' => 'manage_options',
                'edit_post' => 'manage_options',
                'delete_post' => 'manage_options',
                'read_post' => 'manage_options',
            ),
            /** done editing */

            'hierarchical'            => false,
            'menu_position'            => null,
            'supports'                => array('title', 'editor')
        );
        register_post_type('hellotrust-cookies', $args);

        register_taxonomy(
            'hellotrust-cookies-category',
            'hellotrust-cookies',
            array(
                'label' => __('Cookie - Kategorien', 'hellotrust'),
                'rewrite' => array('slug' => 'hellotrust-cookie-category'),
                'hierarchical' => true,
                'public'                => false,
                'publicly_queryable'    => false,
                'exclude_from_search'    => true,
                'show_ui'                => true,
                'show_in_nav_menus'        => false,
                'has_archive'            => false,
                'query_var'                => true,
                'rewrite'                => false,
            )
        );
    }

    public function sitemap_exclude_post_type($value, $post_type)
    {
        if ($post_type == 'hellotrust-cookies') {
            return true;
        }
    }

    public function sitemap_exclude_taxonomy($value, $taxonomy)
    {
        if ($taxonomy == 'hellotrust-cookies-category') {
            return true;
        }
    }



    public function notice_no_api_key()
    {
        $class = 'notice notice-error';
        $message = sprintf(__('<strong>hellotrust:</strong> Ups! Wir konnten leider keinen Lizenzschlüssel finden. Du kannts diesen <a href="%s">hier eingeben</a>, oder hier einen <a target="_blank" href="https://hellotrust.de/?utm_source=hellotrust-settings&utm_medium=link&utm_campaign=no-license-key">Lizenzschlüssel kaufen</a>.', 'hellotrust'), admin_url('/edit.php?post_type=hellotrust-cookies&page=hellotrust'));

        printf('<div class="%1$s"><p>%2$s</p></div>', esc_attr($class),  $message);
    }

    public function notice_no_cookies()
    {
        $class = 'notice notice-error';
        $message = __('<strong>hellotrust:</strong> Wir haben bisher noch keine Cookies vom hellotrust-Server erhalten. Der Scanvorgang kann bis zu 24  Stunden dauern. Solltest du nach 24 Stunden noch keine Daten angezeigt bekommen, wende dich bitte an den hellotrust Support.', 'hellotrust');

        printf('<div class="%1$s"><p>%2$s</p></div>', esc_attr($class),  $message);
    }

    public function admin_menu_options()
    {
        add_submenu_page(
            'edit.php?post_type=hellotrust-cookies',
            __('hellotrust - Einstellungen', 'hellotrust'),
            __('Einstellungen', 'hellotrust'),
            'manage_options',
            'hellotrust',
            array($this, 'page_options')
        );

        add_submenu_page(
            'edit.php?post_type=hellotrust-cookies',
            __('hellotrust - Hilfe', 'hellotrust'),
            __('Hilfe', 'hellotrust'),
            'manage_options',
            'help',
            array($this, 'page_help')
        );
    }

    /*public function page_stats() {
        echo '
		<div class="wrap">
			<h2>' . __( 'hellotrust - Statistik', 'hellotrust' ) . '</h2>
			<p>' . __( 'Übersicht für akzeptierte und abgelehnte Cookies', 'hellotrust' ) . '</p>';

        ?>

        <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.js"></script>
        <div id="container" style="width: 75%;">
            <canvas id="myChart"></canvas>
        </div>
        <script>
            var ctx = document.getElementById('myChart');
            var myChart = new Chart(ctx, {
                type: 'bar',
                data:  {
                    datasets: [{
                        label: '<?php echo __('Akzeptiert','hellotrust') ?>',
                        data: [10, 20, 30, 40, 60, 20, 28, 11, 28, 59, 69],
                        backgroundColor:'green'
                    }, {
                        label: '<?php echo __('Abgelehnt','hellotrust') ?>',
                        data: [5, 11, 21, 10, 5, 19, 5, 3, 6, 2, 9, 1],
                        backgroundColor:'red'
                    }],
                    labels: ['January', 'February', 'March', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'November', 'Dezember']
                },
                options: {
                    scales: {
                        yAxes: [{
                            ticks: {
                                beginAtZero: true
                            }
                        }]
                    }
                }
            });

        </script>
        <p>&nbsp;</p>
        <?php
        echo '		
			<div class="hellotrust-settings">
				'.$this->credits.'
			</div>
			<div class="clear"></div>
		</div>';
    }*/

    public function page_help()
    {
?>
        <script>
            window.location = "https://hellotrust.de/support/";
        </script>
        <?php
    }

    public function page_options()
    {
        echo '
		<div class="wrap">
			<h2 style="margin-bottom:10px;"><img src="' . plugins_url('assets/fingerprint.svg', __FILE__) . '" style="    width: 21px;margin-right: 4px;margin-bottom: -7px;" /> 
			' . __('hellotrust', 'hellotrust') . ' — 
			' . __('Einstellungen', 'hellotrust') . '
			</h2>
			<div class="hellotrust-settings">';

        if (isset($_GET['result'])) {
            echo get_home_url() . '
				<pre>Result:
				
				' . date("d.m.Y - H:m:s", get_option('hellotrust_last_api_call')) . '
						
				' . print_r(get_option('hellotrust_cookies_used'), true) . '
				
				' . print_r(get_option('hellotrust_privacy_policy'), true) . '
                </pre>';
        }

        if (isset($_GET['recrawl'])) {
        ?>
            <div class="notice notice-success is-dismissible">
                <p><?php echo __('Ihre Webseite wird in Kürze neu gecrawlt um mögliche weitere Cookies zu finden.', 'hellotrust'); ?></p>
            </div>
        <?php
            hellotrust_API::makeAPIcall($this->options['general']['api_key'], 'get_cookies');
            $this->hellotrust_hourly_event();
        }

        echo '
				<form action="options.php" method="post">
				<div class="ht_form_wrapper">';

        settings_fields('hellotrust_options');
        do_settings_sections('hellotrust_options');

        echo '</div>
				<p class="submit">';
        submit_button('', 'primary', 'save_hellotrust_options', false);
        echo ' ';
        echo '
				</p>
				</form>
			</div>
			<div class="clear"></div>
			' . $this->credits . '
		</div>';
    }

    public function register_settings()
    {
        register_setting('hellotrust_options', 'hellotrust_options', array($this, 'validate_options'));
        add_settings_section('hellotrust_configuration', __('Einstellungen', 'hellotrust'), array($this, 'ht_section_configuration'), 'hellotrust_options');

        // api
        add_settings_field('ht_option_api_key', __('Lizenzschlüssel', 'hellotrust'), array($this, 'ht_option_api_key'), 'hellotrust_options', 'hellotrust_configuration');
        add_settings_field('ht_option_api_last_seen', __('Letzter API Abruf', 'hellotrust'), array($this, 'ht_option_api_last_seen'), 'hellotrust_options', 'hellotrust_configuration');
        add_settings_field('ht_option_api_last_seen', __('Domain', 'hellotrust'), array($this, 'ht_option_domain'), 'hellotrust_options', 'hellotrust_configuration');
        if ($this->options['general']['api_key'] != '') {
            add_settings_field('ht_show_cookie_box', __('Cookie Box deaktivieren?', 'hellotrust'), array($this, 'ht_deactivate_cookie_box'), 'hellotrust_options', 'hellotrust_configuration');
            add_settings_field('ht_deactivate_content_blocker', __('Content Blocker deaktivieren?', 'hellotrust'), array($this, 'ht_deactivate_content_blocker'), 'hellotrust_options', 'hellotrust_configuration');
            add_settings_field('ht_active_loggendin', __('Aktiviert für angemeldete Benutzer?', 'hellotrust'), array($this, 'ht_activate_for_loggedin'), 'hellotrust_options', 'hellotrust_configuration');

            // Shortcodes
            add_settings_section('hellotrust_configuration_shortcodes', __('Shortcodes', 'hellotrust'), array($this, 'ht_section_configuration'), 'hellotrust_options');
            add_settings_field('ht_shortcode', __('Shortcode - Datenschutzerklärung', 'hellotrust'), array($this, 'ht_shortcode'), 'hellotrust_options', 'hellotrust_configuration_shortcodes');

            if ($this->options['general']['deactivate_cookie_box'] != 'yes') {
                add_settings_field('ht_push_api_call', __('Cookies scannen', 'hellotrust'), array($this, 'ht_push_api_call'), 'hellotrust_options', 'hellotrust_configuration');

                // Links
                add_settings_field('ht_link_imprint', __('Link Impressum', 'hellotrust'), array($this, 'ht_link_imprint'), 'hellotrust_options', 'hellotrust_configuration');
                add_settings_field('ht_link_privacy_police', __('Link Datenschutzerklärung', 'hellotrust'), array($this, 'ht_link_privacy_police'), 'hellotrust_options', 'hellotrust_configuration');

                // Design
                add_settings_section('hellotrust_configuration_design', __('Optik', 'hellotrust'), array($this, 'ht_section_configuration'), 'hellotrust_options');

                add_settings_field('ht_highlight_color', __('Highlight Farbe', 'hellotrust'), array($this, 'ht_highlight_color'), 'hellotrust_options', 'hellotrust_configuration_design');
                add_settings_field('ht_highlight_text_color', __('Textfarbe für Highlight Button', 'hellotrust'), array($this, 'ht_highlight_text_color'), 'hellotrust_options', 'hellotrust_configuration_design');
                add_settings_field('ht_text_color', __('Textfarbe normaler Text für Cookie-Box', 'hellotrust'), array($this, 'ht_text_color'), 'hellotrust_options', 'hellotrust_configuration_design');
                add_settings_field('ht_popup_background_color', __('Hintergrundfarbe für Cookie-Box', 'hellotrust'), array($this, 'ht_popup_background_color'), 'hellotrust_options', 'hellotrust_configuration_design');
                add_settings_field('ht_fixed_link_icon_or_text', __('Text zur Datenschutzerklärung?', 'hellotrust'), array($this, 'ht_fixed_link_cookie_popup_icon_or_text'), 'hellotrust_options', 'hellotrust_configuration_design');
                add_settings_field('ht_hide_row_version_and_info', __('Fußzeile im Popup verstecken?', 'hellotrust'), array($this, 'ht_hide_row_version_and_info'), 'hellotrust_options', 'hellotrust_configuration_design');
                add_settings_field('ht_affiliate_text', __('Affiliate Text', 'hellotrust'), array($this, 'ht_affiliate_text'), 'hellotrust_options', 'hellotrust_configuration_design');

                add_settings_section('hellotrust_configuration_translations', __('Übersetzungen', 'hellotrust'), array($this, 'ht_section_configuration'), 'hellotrust_options');
                // Texts
                add_settings_field('ht_popup_headline', __('Popup Überschrift', 'hellotrust'), array($this, 'ht_popup_headline'), 'hellotrust_options', 'hellotrust_configuration_translations');
                add_settings_field('ht_popup_intro', __('Popup Einleitungstext', 'hellotrust'), array($this, 'ht_popup_intro'), 'hellotrust_options', 'hellotrust_configuration_translations');
                add_settings_field('ht_accept_text', __('Button Akzeptieren', 'hellotrust'), array($this, 'ht_accept_text'), 'hellotrust_options', 'hellotrust_configuration_translations');
                add_settings_field('ht_btn_only_necessary_text', __('Button notwendige Cookies akzeptieren', 'hellotrust'), array($this, 'ht_btn_only_necessary_text'), 'hellotrust_options', 'hellotrust_configuration_translations');
                add_settings_field('ht_individual_cookies_text', __('Button individuelle Cookies wählen', 'hellotrust'), array($this, 'ht_individual_cookies_text'), 'hellotrust_options', 'hellotrust_configuration_translations');
                add_settings_field('ht_btn_only_selected_text', __('Button ausgewählte Cookies speichern', 'hellotrust'), array($this, 'ht_btn_only_selected_text'), 'hellotrust_options', 'hellotrust_configuration_translations');
            }
        }
    }

    function ht_section_configuration()
    {
    }

    public function ht_option_api_key()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="text" class="regular-text" name="hellotrust_options[api_key]" value="' . esc_attr($this->options['general']['api_key']) . '" />
			<p class="description">' . __('Bitte entnehmen Sie diesen aus der Registrierung von unserem Portal unter <a href="https://hellotrust.de" target="_blank">hellotrust.de</a>', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_option_api_last_seen()
    {
        echo '
		<fieldset>
			<div>
			' . date_i18n(get_option('date_format') . " - " . get_option('time_format'), get_option('hellotrust_last_api_call')) . '
			</div>
		</fieldset>';
    }

    public function ht_option_domain()
    {
        echo '
		<fieldset>
			<div>
			' . get_home_url() . '
			</div>
		</fieldset>';
    }

    public function ht_deactivate_cookie_box()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="checkbox" class="modernswitch" name="hellotrust_options[deactivate_cookie_box]" value="yes" ' . (($this->options['general']['deactivate_cookie_box'] != 'yes') ? '' : ' checked="checked"') . ' />
			<p class="description">' . __('Falls nur die Datenschutzerklärung als Shortcode genutzt werden soll, kann hier die hellotrust Cookie Box komplett deaktiviert werden', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_deactivate_content_blocker()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="checkbox" class="modernswitch" name="hellotrust_options[deactivate_content_blocker]" value="yes" ' . (($this->options['general']['deactivate_content_blocker'] != 'yes') ? '' : ' checked="checked"') . ' />
			<p class="description">' . __('Falls Sie den automatischen Content-Blocker für Videos/iFrames etc. deaktivieren möchten, kann der Content Blocker hier deaktiviert werden', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_activate_for_loggedin()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="checkbox" class="modernswitch" name="hellotrust_options[activate_hellotrust_logged_in]" value="yes" ' . (($this->options['general']['activate_hellotrust_logged_in'] != 'yes') ? '' : ' checked="checked"') . ' />
			</div>
		</fieldset>';
    }

    /**
     * Popup Headline
     */
    public function ht_popup_headline()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="ht_accept_text">
                        <input type="text" class="regular-text" name="hellotrust_options[popup_headline_' . $language . ']" value="' . esc_attr($this->options['general']['popup_headline_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Dieser Text wird als Überschrift in %s in der Cookie-Box verwendet.', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    /**
     * Cookie message option.
     */
    public function ht_popup_intro()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="ht_message_text">
                        <textarea name="hellotrust_options[popup_intro_' . $language . ']" class="large-text" cols="50" rows="3">' . esc_textarea($this->options['general']['popup_intro_' . $language]) . '</textarea>
                        <p class="description">' . sprintf(__('Dieser Text wid im Cookie-Popup zur Einleitung in %s angezeigt', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    /**
     * Accept cookie label option.
     */
    public function ht_accept_text()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="ht_accept_text">
                        <input type="text" class="regular-text" name="hellotrust_options[accept_text_' . $language . ']" value="' . esc_attr($this->options['general']['accept_text_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Dieser Text wird  in %s verwendet um alle Cookies zu akzeptieren.', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }


    public function ht_individual_cookies_text()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="ht_accept_text">
                        <input type="text" class="regular-text" name="hellotrust_options[individual_cookies_text_' . $language . ']" value="' . esc_attr($this->options['general']['individual_cookies_text_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Dieser Text wird in %s für den Button für die Auswahl "individueller Cookies" genutzt.', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    public function ht_btn_only_necessary_text()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="ht_accept_text">
                        <input type="text" class="regular-text" name="hellotrust_options[only_necessary_text_' . $language . ']" value="' . esc_attr($this->options['general']['only_necessary_text_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Dieser Text wird in %s für den Button für die Auswahl "nur notwendige Cookies" genutzt.', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    public function ht_btn_only_selected_text()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="ht_accept_text">
                        <input type="text" class="regular-text" name="hellotrust_options[only_checked_text_' . $language . ']" value="' . esc_attr($this->options['general']['only_checked_text_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Dieser Text wird in %s für den Button für die Auswahl "nur ausgewählte Cookies" genutzt.', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    public function ht_link_imprint()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="link_imprint_' . $language . '">
                        <input type="text" class="regular-text" name="hellotrust_options[link_imprint_' . $language . ']" value="' . esc_attr($this->options['general']['link_imprint_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Direkte URL zum Impressum (für Cookie-Box) in der Sprache %s', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    public function ht_link_privacy_police()
    {
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            echo '
                <fieldset>
                    <h4>' . $friendly_language_name . ':</h4>
                    <div id="link_privacy_police_' . $language . '">
                        <input type="text" class="regular-text" name="hellotrust_options[link_privacy_police_' . $language . ']" value="' . esc_attr($this->options['general']['link_privacy_police_' . $language]) . '" />
                    <p class="description">' . sprintf(__('Direkte URL zur Datenschutzerklärung (für Cookie-Box) in der Sprache %s', 'hellotrust'), $friendly_language_name) . '</p>
                    </div>
                </fieldset>';
        }
    }

    public function ht_highlight_color()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="text" class="highlight_color" name="hellotrust_options[highlight_color]" value="' . esc_attr($this->options['general']['highlight_color']) . '" />
			<p class="description">' . __('Farbe zum hervorheben der Buttons und Links', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_highlight_text_color()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="text" class="highlight_text_color" name="hellotrust_options[highlight_text_color]" value="' . esc_attr($this->options['general']['highlight_text_color']) . '" />
			<p class="description">' . __('Farbe zum hervorheben der Buttons und Links', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_text_color()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="text" class="highlight_text_color" name="hellotrust_options[text_color]" value="' . esc_attr($this->options['general']['text_color']) . '" />
			<p class="description">' . __('Normale Textfarbe der Cookie-Box', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_popup_background_color()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="text" class="highlight_text_color" name="hellotrust_options[popup_background_color]" value="' . esc_attr($this->options['general']['popup_background_color']) . '" />
			<p class="description">' . __('Hintergrundfarbe der Cookie-Box', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_fixed_link_cookie_popup_icon_or_text()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="checkbox" class="modernswitch" name="hellotrust_options[fixed_link_cookie_popup_icon_or_text]" value="yes" ' . (($this->options['general']['fixed_link_cookie_popup_icon_or_text'] != 'yes') ? '' : ' checked="checked"') . ' />
			<p class="description">' . __('Mitlaufender Text/Icon zum Cookie-Popup am Bildschirmrand', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_hide_row_version_and_info()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<input type="checkbox" class="modernswitch" name="hellotrust_options[hide_row_version_and_info]" value="yes" ' . (($this->options['general']['hide_row_version_and_info'] != 'yes') ? '' : ' checked="checked"') . ' />
			<p class="description">' . __('Zeile mit Versionshinweis sowie hellotrust Nutzung verstecken', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_affiliate_text()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<textarea class="affiliate_text" name="hellotrust_options[affiliate_text]" rows="4">' . esc_attr($this->options['general']['affiliate_text']) . '</textarea>
			<p class="description">' . __('Affiliate Text für das Popup. Für eine Affiliate Partnerschaft bitte hellotrust kontaktieren für einen eigenen Affiliate Link. Wenn nicht gewünscht, leer lassen.', 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_shortcode()
    {
        $shortcode = "hellotrust_privacy_policy";
        $description = "";
        echo '
		<fieldset>
			<div id="ht_accept_text">
            <pre>[hellotrust_privacy_policy]</pre>
            <pre>[hellotrust_privacy_policy language="en_GB"]</pre>
			<p class="description">' . __($description, 'hellotrust') . '</p>
			</div>
		</fieldset>';
    }

    public function ht_push_api_call()
    {
        echo '
		<fieldset>
			<div id="ht_accept_text">
				<button name="push-api-call" id="push-api-call" class="button button-primary"><i class="dashicons dashicons-controls-play" style="margin-top:3px"></i> ' . __('Jetzt Cookie Scan anstoßen', 'hellotrust') . '</button>
			<p class="description">' . __('Die hellotrust Server starten daraufhin innerhalb der nächsten Stunden einen erneuten Cookie-Crawl. Dies kann einige Zeit dauern. ', 'hellotrust') . '</p>
			';
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function($) {
                $('#push-api-call').on('click', function(e) {
                    e.preventDefault();
                    window.location = '<?php echo admin_url('edit.php?post_type=hellotrust-cookies&page=hellotrust&recrawl') ?>';
                })
            });
        </script>
<?php echo '
			</div>
		</fieldset>';
    }

    public function validate_options($input)
    {
        if (!check_admin_referer('hellotrust_options-options'))
            return $input;

        if (!current_user_can(apply_filters('ht_manage_cookie_notice_cap', 'manage_options')))
            return $input;

        if (isset($_POST['save_hellotrust_options'])) {
            // texts
            $input['api_key'] = $input['api_key'];

            $this->hellotrust_hourly_event();
        }

        return $input;
    }

    /*public function get_allowed_html() {
        return apply_filters(
            'ht_refuse_code_allowed_html',
            array_merge(
                wp_kses_allowed_html( 'post' ),
                array(
                    'script' => array(
                        'type' => array(),
                        'src' => array(),
                        'charset' => array(),
                        'async' => array()
                    ),
                    'noscript' => array(),
                    'style' => array(
                        'type' => array()
                    ),
                    'iframe' => array(
                        'src' => array(),
                        'height' => array(),
                        'width' => array(),
                        'frameborder' => array(),
                        'allowfullscreen' => array()
                    )
                )
            )
        );
    }*/

    /*private function print_cookie_table($cookies, $language='de') {
        if(!is_array($cookies) && !count($cookies)) {
            $cookies = array();
        }
        $html = '<table class="hellotrust_used_cookies">';
        $html .= '<thead>
                    <th>'.__( 'Cookie Name', 'hellotrust' ).'</th>
                    <th>'.__( 'Herkunft', 'hellotrust' ).'</th>
                    <th>'.__( 'Speicherdauer', 'hellotrust' ).'</th>
                    <th>'.__( 'Zweck', 'hellotrust' ).'</th>';
        foreach($cookies as $cookie) {
            $html .= '<tr>';
            $html .= '<td>'.$cookie->{"name_$language"}.'</td>';
            $html .= '<td>'.$cookie->domain.'</td>';
            $html .= '<td>'.$cookie->{"expiration_$language"}.'</td>';
            $html .= '<td>'.$cookie->{"description_$language"}.'</td>';
            $html .= '</tr>';
        }

        $html .= '</table>';
        return $html;
    }*/

    //public function shortcode_cookies_used() {
    //    $private_used_cookies = array();
    /*$categories = get_option('hellotrust_cookies_used');
        foreach($categories as $category) {
            $cat_name = $category->name;
            foreach($category->cookies[0] as $cookie) {
                $cookie->category = $cat_name;
                $private_used_cookies[$cookie->id] = $cookie;
            }
        }*/
    //    return $this->print_cookie_table($private_used_cookies);
    //}

    /*public function shortcode_cookies_accepted() {
        $cookie_array = array();
        foreach($this->getAcceptedCookiesFromClient() as $cookie) {
            $cookie_array[] = $this->getCookieByID($cookie);
        }

        return $this->print_cookie_table($cookie_array);
    }*/

    public function shortcode_privacy_policy($atts)
    {
        $atts = shortcode_atts(
            array(
                'language' => $this->current_language,
            ),
            $atts,
            'hellotrust_privacy_policy'
        );

        $api_language = $this->language_api($atts['language']);
        $option = get_option('hellotrust_privacy_policy');
        $content = "<!-- hellotrust: Language Data Privacy: $api_language -->\n";

        if (isset($option->{"text_$api_language"}) && $option->{"text_$api_language"} != "") {
            $content .= $option->{"text_$api_language"};
        } else {
            $content .= "<!-- hellotrust: Data Privacy Result empty (Language: $api_language) -->";
        }
        return apply_filters('hellotrust_privacy_police_output', $content);
    }

    public function create_content_blocker_html($identifier, $content, $classes = "")
    {
        // Disable content blocker if GET or Server parameter hellotrust_disable_contentblocker isset
        if ((isset($_GET['hellotrust_disable_contentblocker']) && $_GET['hellotrust_disable_contentblocker'] == "1") || (isset($_SERVER['hellotrust_disable_contentblocker']) && $_SERVER['hellotrust_disable_contentblocker'] == "1")) {
            return $content;
        }

        $return = '<template id="' . $identifier . '">';
        $return .= $content;
        $return .= '</template>';

        $return .= '<div id="hellotrust_contentblocker_wrapper__' . $identifier . '"></div><div class="hellotrust hellotrust__contentblocker ' . $classes . '" id="hellotrust_contentblocker_hint__' . $identifier . '">'
            . __('Dieser Inhalt wurde blockiert.', 'hellotrust')
            . 'Durch das laden akzeptieren Sie unsere <a href="' . esc_attr($this->checkStringTranslated($this->options['general']['link_privacy_police_' . $this->current_language], $this->options['general']['link_privacy_police_de_DE'])) . '">' . __('Datenschutzerklärung', 'hellotrust') . '</a>.
            <button class="btn hellotrust__btn_dataprivacy" data-hellotrustcontentid="' . $identifier . '">' . __('Inhalt laden', 'hellotrust') . '</button>
            <button class="btn hellotrust__btn_dataprivacy_load_all">' . __('Alle Inhalte von Dritten laden', 'hellotrust') . '</button></div>';


        return $return;
    }

    public function shortcode_content_blocker($atts, $content)
    {
        if (is_user_logged_in() && $this->options['general']['activate_hellotrust_logged_in'] == 'no') return $content;

        $atts = shortcode_atts(
            array(
                'cookies_accepted' => null,
                'type' => ''
            ),
            $atts,
            'hellotrust_content_blocker'
        );


        if (!($atts['cookies_accepted'] && is_numeric($atts['cookies_accepted']))) {
            return "Parameter cookies_accepted fehlt!";
        }

        if ($this->options['general']['deactivate_content_blocker'] == 'yes') {
            return $content;
        }

        $identifier = $atts['cookies_accepted'];

        return $this->create_content_blocker_html($identifier, $content, "hellotrust-cookie-contentblocker");
    }

    /*public function shortcode_history() {
        if(isset($_COOKIE['hellotrust_history'])) {
            $output = $_COOKIE['hellotrust_history'];
        } else {
            $output = "";
        }
        return apply_filters('hellotrust_history_output', $output);
    }*/

    public function hellotrust_hourly_event()
    {
        // for cronjob

        if (isset($this->options['general']['api_key']) && $this->options['general']['api_key'] != "") {
            // get cookies
            $response_cookies           = hellotrust_API::makeAPIcall($this->options['general']['api_key'], 'get_cookies');
            $response_privacy_policy    = hellotrust_API::makeAPIcall($this->options['general']['api_key'], 'get_privacy_policy');

            // get privacy policy
            if ($response_cookies) {
                update_option('hellotrust_cookies_used', $response_cookies, 'no');
            }
            if ($response_privacy_policy) {
                update_option('hellotrust_privacy_policy', $response_privacy_policy, 'no');
            }

            if ($response_cookies || $response_privacy_policy) {
                update_option('hellotrust_last_api_call', current_time('timestamp'), true);
            }

            $this->createOrUpdateExternalCrawledCookiesAndCategories();
        }
    }

    private function createOrUpdateExternalCrawledCookiesAndCategories()
    {
        $cookies = get_option('hellotrust_cookies_used');
        if ($cookies) {
            foreach ($cookies as $cookieObject) {
                if (isset($cookieObject) && is_object($cookieObject)) {
                    $this->createOrUpdateLocalCookieCategoriesByUIDfromExternal($cookieObject);
                    $this->createOrUpdateLocalCookieByUIDfromExternal($cookieObject);
                }
            }
        }
    }

    private function createOrUpdateLocalCookieCategoriesByUIDfromExternal($cookieObject)
    {
        if (isset($cookieObject->category) && is_object($cookieObject->category)) {
            $category = $cookieObject->category;
            if (isset($cookieObject->category->id)) {
                $uid = $cookieObject->category->id;
            } else {
                $uid = '(undefined)';
            }
        } else {
            if (isset($cookieObject->template) && isset($cookieObject->template->standard_category)) {
                $category = $cookieObject->template->standard_category;
            } else {
                $category = '(undefined)';
            }
            if (isset($cookieObject->id)) {
                $uid = $cookieObject->id;
            } else {
                $uid = '(undefinied)';
            }
        }

        $terms = get_terms(array(
            'hide_empty' => false, // also retrieve terms which are not used yet
            'meta_query' => array(
                array(
                    'key'       => 'hellotrust_external_category_uid',
                    'value'     => $uid, // uid
                    'compare'   => '='
                )
            ),
            'taxonomy'  => 'hellotrust-cookies-category',
        ));

        if ($terms) {
            foreach ($terms as $term) {
                if (isset($category->name_de_DE)) {
                    $cat_name = $category->name_de_DE;
                } elseif (isset($category->name)) {
                    $cat_name = $category->name;
                } else {
                    $cat_name = '(undefined category)';
                }
                wp_update_term($term->term_id, 'hellotrust-cookies-category', array(
                    'name' => $cat_name
                ));
                if (isset($category->locked) && $category->locked == 1) {
                    update_term_meta($term->term_id, 'hellotrust_locked', "1");
                } else {
                    update_term_meta($term->term_id, 'hellotrust_locked', "0");
                }
                foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
                    $api_language = $this->language_api($language);
                    if (isset($category->{"name_$api_language"})) {
                        update_term_meta($term->term_id, 'name_' . $language, $category->{"name_$api_language"});
                    }
                    if (isset($category->{"description_$api_language"})) {
                        update_term_meta($term->term_id, 'description_' . $language, $category->{"description_$api_language"});
                    }
                }
                update_term_meta($term->term_id, 'hellotrust_external_category_uid', $uid);
                update_term_meta($term->term_id, 'hellotrust_last_updated', current_time('timestamp'));
            }
        } else {
            if (isset($category->description_de)) {
                $cat_description = $category->description_de;
            } else {
                $cat_description = '';
            }
            if (isset($category->name_de_DE)) {
                $cat_name = $category->name_de_DE;
            } elseif (isset($category->name)) {
                $cat_name = $category->name;
            } else {
                $cat_name = '(undefined category)';
            }
            $term = wp_insert_term(
                $cat_name,
                'hellotrust-cookies-category', // the taxonomy
                array(
                    'description' => $cat_description,
                )
            );
            if (!is_wp_error($term)) {
                if ($category->locked == 1) {
                    update_term_meta($term['term_id'], 'hellotrust_locked', "1");
                } else {
                    update_term_meta($term['term_id'], 'hellotrust_locked', "0");
                }
                foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
                    $api_language = $this->language_api($language);
                    if (isset($category->{"name_$api_language"})) {
                        update_term_meta($term['term_id'], 'name_' . $language, $category->{"name_$api_language"});
                    }
                    if (isset($category->{"description_$api_language"})) {
                        update_term_meta($term['term_id'], 'description_' . $language, $category->{"description_$api_language"});
                    }
                }
                update_term_meta($term['term_id'], 'hellotrust_external_category_uid', $uid);
                update_term_meta($term['term_id'], 'hellotrust_last_updated', current_time('timestamp'));
            } else {
                //error
            }
        }
    }

    private function createOrUpdateLocalCookieByUIDfromExternal($cookieObject)
    {
        if (!isset($cookieObject->template)) {
            return;
        }
        if (isset($cookieObject->category) && is_object($cookieObject->category)) {
            $category = $cookieObject->category;
        } else {
            if (isset($cookieObject->template)) {
                $category = $cookieObject->template->standard_category;
            }
        }

        $cookie = $cookieObject->template;

        $alreadyCreatedCookies = get_posts(array(
            'post_type' => 'hellotrust-cookies',
            'posts_per_page' => -1,
            'post_status'   => 'publish',
            'meta_query' => array(
                array(
                    'key' => 'hellotrust_external_uid',
                    'value' => $cookie->id,
                    'compare' => '='
                ),
            )
        ));
        if ($alreadyCreatedCookies) {
            foreach ($alreadyCreatedCookies as $post) {
                $post_id = $post->ID;

                wp_update_post(array('ID' => $post_id, 'post_title' => $cookie->name));
                wp_set_object_terms($post_id, $category->name_de_DE, 'hellotrust-cookies-category');
            }
            wp_reset_postdata();
        } else {
            $post_id = wp_insert_post(array(
                'post_title'    => wp_strip_all_tags($cookie->name),
                'post_author'   => get_current_user_id(),
                'post_type'     => 'hellotrust-cookies',
                'post_status'   => 'publish',
                'tax_input'    => array(
                    'hellotrust-cookies-category' => $category->name_de_DE,
                ),
                'meta_input'   => array(
                    'hellotrust_external_uid' => $cookie->id,
                ),
            ));
            wp_set_object_terms($post_id, $category->name_de_DE, 'hellotrust-cookies-category');
        }

        if (is_object($cookie->vendor)) {
            update_post_meta($post_id, 'vendor_opt_out', $cookie->vendor->opt_out);
            update_post_meta($post_id, 'vendor_privacy_policy', $cookie->vendor->privacy_policy);
            update_post_meta($post_id, 'vendor', $cookie->vendor->name);
        }
        if (isset($cookie->cookie_names) && is_array($cookie->cookie_names) && count($cookie->cookie_names)) {
            update_post_meta($post_id, 'cookie_names', implode(",", $cookie->cookie_names));
        }
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            $api_language = $this->language_api($language);
            if (isset($cookie->{"description_$api_language"})) {
                update_post_meta($post_id, 'description_' . $language, $cookie->{"description_$api_language"});
            }
        }

        if (isset($cookie->expires)) {
            update_post_meta($post_id, 'expiration', $cookie->expires);
        }
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            $api_language = $this->language_api($language);
            if (isset($cookie->{"expires_$api_language"})) {
                update_post_meta($post_id, 'expiration_' . $language, $cookie->{"expires_$api_language"});
            }
        }

        update_post_meta($post_id, 'hellotrust_last_updated', current_time('timestamp'));
    }

    public function frontend_style_and_scripts()
    {
        if (is_user_logged_in() && $this->options['general']['activate_hellotrust_logged_in'] == 'no') return;

        wp_enqueue_script('hellotrust-cookie-js', plugins_url('assets/js.cookie.min.js', __FILE__), null, $this->defaults['version']);
        wp_enqueue_style('hellotrust-frontend-css', plugins_url('assets/hellotrust_cookie_popup.css', __FILE__), null, $this->defaults['version']);
        wp_enqueue_script('hellotrust-frontend-js', plugins_url('assets/hellotrust_cookie_popup.js', __FILE__), array('jquery', 'hellotrust-cookie-js'), $this->defaults['version']);

        wp_localize_script('hellotrust-frontend-js', 'htargs', array(
            'ajax_url' => admin_url('admin-ajax.php')
        ));
    }

    public function buffer_start()
    {
        if (is_user_logged_in() && $this->options['general']['activate_hellotrust_logged_in'] == 'no') return;
        ob_start();
    }

    public function buffer_end()
    {
        if (is_user_logged_in() && $this->options['general']['activate_hellotrust_logged_in'] == 'no') return;

        $contents = $this->contentblocker(ob_get_contents());
        ob_end_clean();
        echo $contents;
    }

    public function contentblocker($content)
    {
        $content = preg_replace_callback('#<iframe.*?\/iframe>|<object.*?\/object>|<embed.*?>#is', array($this, 'hintBlockedContent'), $content);
        return $content;
    }

    public function hintBlockedContent($content)
    {
        $content = $content[0];
        return $this->create_content_blocker_html(md5($content), $content);
    }

    public function getCookieByID($id)
    {
        $cookie = get_post($id);
        if (!$cookie) {
            return;
        }

        $cookie->name                       = $cookie->post_title;
        foreach ($this->defaults['languages'] as $friendly_language_name => $language) {
            $cookie->{"name_$language"} = get_post_meta($id, 'name_' . $language, true);
            $cookie->{"description_$language"} = get_post_meta($id, 'description_' . $language, true);
            $cookie->{"expiration_$language"} = get_post_meta($id, 'expiration_' . $language, true);
        }
        $cookie->expiration                 = get_post_meta($id, 'expiration', true);
        $cookie->hellotrust_last_updated    = get_post_meta($id, 'hellotrust_last_updated', true);
        $cookie->code                       = get_field('code', $id);

        return $cookie;
    }

    public function getScriptCodes($cookies)
    {
        $script_codes = array();

        if (isset($cookies) && is_array($cookies)) {
            foreach ($cookies as $cookie_id) {
                $singlecookie = $this->getCookieByID($cookie_id);
                if (isset($singlecookie->code)) {
                    $script_codes[] = $singlecookie->code;
                }
            }
        }

        return implode("\n", $script_codes);
    }

    public function getFrontendScripts($cookies)
    {
        /*if(isset($accepted_cookie_ids) && is_array($accepted_cookie_ids)) {
            // Filtert alle neu akzeptierten Cookies, indem die bereits akzeptieren (getAcceptedCookiesFromClient) und essentiellen (getEssentialCookies) herausgefiltert werden
            $cookies = array_diff($accepted_cookie_ids, $this->getAcceptedCookiesFromClient(), $this->getEssentialCookies());
        } else {
			$cookies = array_merge($this->getAcceptedCookiesFromClient(), $this->getEssentialCookies());
        }*/

        // Cookie-IDs müssen vom Client übermittelt werden, um die script-Codes zu erhalten
        return $this->getScriptCodes(array_unique($cookies));
    }

    /*public function isCookiesAccepted() {
        if(isset($_COOKIE['hellotrust_cookies_accepted'])) {
            return true;
        } else {
            return false;
        }
    }*/

    /*public function getAcceptedCookiesFromClient() {
        if(isset($_COOKIE['hellotrust_cookies_accepted'])) {
            $cookies = ($_COOKIE['hellotrust_cookies_accepted']);
            return explode(",", $cookies);
        } else {
            return array();
        }
    }*/

    public function getEssentialCookies()
    {
        $return = array();
        $term_cookies_categories = get_terms('hellotrust-cookies-category', array(
            'hide_empty' => true,
            'meta_query' => array(
                array(
                    'key'       => 'hellotrust_locked',
                    'value'     => "1",
                    'compare'   => '='
                )
            ),
        ));
        foreach ($term_cookies_categories as $cat) {
            $cookies = get_posts(array(
                'post_type' => 'hellotrust-cookies',
                'posts_per_page' => -1,
                'post_status' => 'publish',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'hellotrust-cookies-category',
                        'field' => 'term_id',
                        'terms' => $cat->term_id,
                    )
                )
            ));
            foreach ($cookies as $cookie) {
                $return[] = $cookie->ID;
            }
        }
        return $return;
    }

    /*public function getAcceptedCookieCategoriesFromClient() {
        $cats = null;

        if(isset($_COOKIE['hellotrust_categories_accepted'])) {
            $cats = sanitize_text_field($_COOKIE['hellotrust_categories_accepted']);
        }

        if($cats) {
            return explode(",", $cats);
        }
        return array();
    }*/

    public function frontend_attach_scripts()
    {
        // Nur notwendige Cookies ausliefern
        echo $this->getFrontendScripts($this->getEssentialCookies());
    }

    /*public function addClientHistory($msg) {
        if(isset($_COOKIE['hellotrust_history'])) {
            $old_history = $_COOKIE['hellotrust_history'];
        } else {
            $old_history = "";
        }
        $new_msg = date("d.m.Y - H:i", current_time( 'timestamp' )).' '.__('Uhr', 'hellotrust').' - '.$msg.'<br>';
        setcookie("hellotrust_history", $new_msg . " " . $old_history, time()+62208000, '/');
    }*/

    /*public function getClientHistory() {
        if(isset($_COOKIE['hellotrust_history'])) {
            return $_COOKIE['hellotrust_history'];
        }
    }*/

    public function frontend_add_cookie_popup()
    {
        if (is_user_logged_in() && $this->options['general']['activate_hellotrust_logged_in'] == 'no') return;

        $add_frontend_css_styles = '
            <style type="text/css">
            #hellotrust_cookie_popup .hellotrust_cookies_btn_accept,
            .toggleWrapper input.mobileToggle:checked + label:before {
                background: ' . $this->options['general']['highlight_color'] . ' !important;
                color: ' . $this->options['general']['highlight_text_color'] . ' !important;
            }
            
            #hellotrust_cookie_popup .htc_inner {
                background:  ' . $this->options['general']['popup_background_color'] . ' !important;
                color:   ' . $this->options['general']['text_color'] . ' !important;
            }

            #hellotrust_cookie_popup h4.htc_headline {
                color:   ' . $this->options['general']['text_color'] . ' !important;
            }
            
            #hellotrust_cookie_popup .htc_affiliate, #hellotrust_cookie_popup .htc_affiliate a, 
            #hellotrust_cookie_popup .htc_footer, #hellotrust_cookie_popup .htc_footer a,
            #hellotrust_cookie_popup .htc_actions, #hellotrust_cookie_popup .htc_actions a {
                color:   ' . $this->options['general']['text_color'] . ' !important;
            }
            
            #hellotrust_cookie_popup #htc_btn_individual,
            #hellotrust_cookie_popup .htc_categories span,
            .htc_single_category__cookies_toggle a, 
            .htc_single_category__cookies_toggle a:visited,
            .htc_single_category table td a{
                color: ' . $this->options['general']['highlight_color'] . ' !important;
            }
            </style>';
        $html_for_short_output = array();
        $cookies_categories = "";
        $term_cookies_categories = get_terms('hellotrust-cookies-category', array(
            'hide_empty' => true,
        ));
        $i = 1;
        if (isset($term_cookies_categories) && count($term_cookies_categories) == 0) {
            // no data to show
            return;
        }
        foreach ($term_cookies_categories as $cat) {
            $localCookies = get_posts(array(
                'post_type' => 'hellotrust-cookies',
                'posts_per_page' => -1,
                'post_status' => 'publish',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'hellotrust-cookies-category',
                        'field' => 'term_id',
                        'terms' => $cat->term_id,
                    )
                )
            ));
            if ($localCookies) {
                // kategorie nur zeigen wenn lokale cookies gefunden
                if (get_term_meta($cat->term_id, 'hellotrust_locked', true) == '1') {
                    $cat_locked = true;
                } else {
                    $cat_locked = false;
                }
                $cookies_categories .= '
                <div class="htc_single_category">';

                if ($cat_locked) {
                    $hide_category = ' style="display:none;"';
                } else {
                    $hide_category = "";
                }

                /*if(isset($_COOKIE['hellotrust_categories_accepted'])) {
                    if(in_array($cat->term_id, explode(",", $_COOKIE['hellotrust_categories_accepted']))) {
                        $checked = 'checked="checked"';
                    } else {
                        $checked = '';
                    }
                } else {
                    $checked = '';
                }*/
                $checked = '';

                $cookies_categories .= '
                    <div class="toggleWrapper"' . $hide_category . '>
                        <input type="checkbox" name="cat[]" value="' . $cat->term_id . '" ' . (($cat_locked) ? 'data-essential-cats="yes"' : '') . ' class="htc_cookie_group_toggle mobileToggle" data-groupid="' . $cat->term_id . '" id="toggle' . $i . '" ' . $checked . '>
                        <label for="toggle' . $i . '"></label>
                    </div>';
                $cookies_categories .= '<div class="htc_single_category__name">' . $this->checkStringTranslated(get_term_meta($cat->term_id, 'name_' . $this->current_language, true), get_term_meta($cat->term_id, 'name_' . $this->fallback_language, true)) . ' (' . count($localCookies) . ')</div>';
                $cookies_categories .= '<div class="htc_single_category__description">' . $this->checkStringTranslated(get_term_meta($cat->term_id, 'description_' . $this->current_language, true), get_term_meta($cat->term_id, 'description_' . $this->fallback_language, true)) . '</div>';
                $cookies_categories .= '<div class="htc_single_category__cookies_toggle" data-catid="' . $cat->term_id . '"><a href="#" class="htc_single_category__cookies_toggle_inactive">' . __('Cookie-Informationen anzeigen', 'hellotrust') . '</a> <a href="#" class="htc_single_category__cookies_toggle_active">' . __('Cookie-Informationen ausblenden', 'hellotrust') . '</a></div>';
                $cookies_categories .= '<div class="htc_single_category__cookies htc_single_category__cookies_id_' . $cat->term_id . '">';

                foreach ($localCookies as $post) {
                    /*if(isset($_COOKIE['hellotrust_cookies_accepted'])) {
                        if(in_array($post->ID, explode(",", $_COOKIE['hellotrust_cookies_accepted']))) {
                            $checkedCookie = 'checked="checked"';
                        } else {
                            $checkedCookie = '';
                        }
                    } else {
                        $checkedCookie = '';
                    }*/
                    $checkedCookie = '';

                    $cookies_categories .= '
                        <table class="">
                        <tr ' . (($cat_locked) ? 'style="display:none;"' : '') . '>
                            <td width="30%">' . __('Akzeptieren', 'hellotrust') . '</td>
                            <td>
                            <div class="toggleWrapper">
                                <input type="checkbox" name="cookie[]" ' . (($cat_locked) ? 'data-essential-cookies="yes"' : '') . ' data-groupid="' . $cat->term_id . '" class="htc_cookie htc_cookie__group_' . $cat->term_id . ' mobileToggle" ' . $checkedCookie . ' value="' . $post->ID . '" id="toggleCookie' . $post->ID . '">
                                <label for="toggleCookie' . $post->ID . '"></label>
                            </div>                            
                        </tr>
                        <tr>
                            <td>' . __('Name', 'hellotrust') . '</td>
                            <td>' . $this->checkStringTranslated(get_post_meta($post->ID, 'name_' . $this->current_language, true), $post->post_title) . '</td>
                        </tr>
                        <tr>
                            <td>' . __('Anbieter', 'hellotrust') . '</td>
                            <td>' . get_post_meta($post->ID, 'vendor', true) . '</td>
                        </tr>
                        <tr>
                            <td>' . __('Zweck', 'hellotrust') . '</td>
                            <td>' . $this->checkStringTranslated(get_post_meta($post->ID, 'description_' . $this->current_language, true), get_post_meta($post->ID, 'description_' . $this->fallback_language, true)) . '</td>
                        </tr>
                        <tr>
                            <td>' . __('Laufzeit', 'hellotrust') . '</td>
                            <td>' . $this->checkStringTranslated(get_post_meta($post->ID, 'expiration_' . $this->current_language, true), get_post_meta($post->ID, 'expiration_' . $this->fallback_language, true)) . '</td>
                        </tr>';

                    if (get_post_meta($post->ID, 'vendor_privacy_policy', true)) {
                        $cookies_categories .= '
                        <tr>
                            <td>' . __('Weiterführende Infos', 'hellotrust') . '</td>
                            <td><a href="' . get_post_meta($post->ID, 'vendor_privacy_policy', true) . '" target="_blank">' . get_post_meta($post->ID, 'vendor_privacy_policy', true) . '</a></td>
                        </tr>';
                    }

                    if (get_post_meta($post->ID, 'vendor_opt_out', true)) {
                        $cookies_categories .= '
                        <tr>
                            <td>' . __('Opt-Out Link', 'hellotrust') . '</td>
                            <td><a href="' . get_post_meta($post->ID, 'vendor_opt_out', true) . '" target="_blank">' . get_post_meta($post->ID, 'vendor_opt_out', true) . '</a></td>
                        </tr>';
                    }

                    $cookies_categories .= '
                        </table>';
                }

                $cookies_categories .= '</div>';
            }

            $cookies_categories .= '</div>';
            $i++;

            // für kurze übersicht der kategorien
            $html_for_short_output[] = $this->checkStringTranslated(get_term_meta($cat->term_id, 'name_' . $this->current_language, true), get_term_meta($cat->term_id, 'name_' . $this->fallback_language, true));
        }

        $history = '<div id="htc_detail_view_history">
                        <div class="htc_actions htc_actions_second">
                            <a href="#" class="htc_btn_back_to_simple">' . __('Zurück', 'hellotrust') . '</a>
                        </div>';
        /*$client_history = str_replace(", <br>", '<br>', $this->getClientHistory());
        if(!$client_history) {
            $history .= '<i>'.__('(Noch keine Daten vorhanden.)', 'hellotrust').'</i>';
        } else {
            $history .= '<div class="htc_detail_view_history__scroll">'.$client_history.'</div>';
        }*/
        $history .= '<div id="htc_detail_view_history__scroll" class="htc_detail_view_history__scroll"></div>';

        $history .= '</div>';

        $output = $add_frontend_css_styles . '
        
        <div id="hellotrust_cookie_popup"' . /*( ($this->isCookiesAccepted()) ? ' style="display:none;"' : '' )*/ ' style="display:none;"' . '>
            <div class="htc_inner">
                <h4 class="htc_headline">' . esc_attr($this->options['general']['popup_headline_' . $this->current_language]) . '</h4>
                <p class="htc_message">' . esc_attr($this->options['general']['popup_intro_' . $this->current_language]) . '</p>
                <div class="htc_categories">
                    <span>&bull;</span> ' . implode("<span>&bull;</span> ", $html_for_short_output) . '
                </div> 
                <form name="htc_cookie_popup_categories" id="htc_cookie_popup_categories">                        
                    <div id="htc_detail_view_cookies">
                        <div class="htc_actions htc_actions_second">
                            <input type="submit" class="hellotrust_cookies_btn_accept force-all-cookies-selected hellotrust_popup_btn" id="hellotrust_cookies_btn_accept__second" value="' . esc_attr($this->options['general']['accept_text_' . $this->current_language]) . '" />
                            <input type="button" class="htc_btn_only_checked hellotrust_popup_btn" value="' . esc_attr($this->options['general']['only_checked_text_' . $this->current_language]) . '" />
                            <a href="#" class="htc_btn_back_to_simple">' . __('Zurück', 'hellotrust') . '</a>
                        </div>
                        ' . $cookies_categories . '
                    </div>
                </form>
                <div id="htc_view_history">
                    ' . $history . '
                </div>
                <div class="htc_actions htc_actions_first">
                    <input type="submit" class="hellotrust_cookies_btn_accept force-all-cookies-selected hellotrust_popup_btn" id="hellotrust_cookies_btn_accept__first" value="' . esc_attr($this->options['general']['accept_text_' . $this->current_language]) . '" />
                    <input type="button" class="htc_btn_only_necessary_checked hellotrust_popup_btn" value="' . esc_attr($this->options['general']['only_necessary_text_' . $this->current_language]) . '" />
                    <a href="#" id="htc_btn_individual">' . esc_attr($this->options['general']['individual_cookies_text_' . $this->current_language]) . '</a>
                    <a href="#" id="htc_btn_view_history">' . esc_attr($this->options['general']['history_text_' . $this->current_language]) . '</a>
                </div>
                ' . (($this->options['general']['affiliate_text']) ? '<div class="htc_affiliate">' . $this->options['general']['affiliate_text'] . '</div>' : '') . '
                <div class="htc_footer">
                    ' . ((get_option('hellotrust_last_api_call')) ? __('Letzte Prüfung:', 'hellotrust') . ' ' . date("d.m.y - H:i:s", get_option('hellotrust_last_api_call')) . ' ' . __('Uhr', 'hellotrust') . '<br/> '  : '') . '
                    <a href="' . esc_attr($this->checkStringTranslated($this->options['general']['link_privacy_police_' . $this->current_language], $this->options['general']['link_privacy_police_de_DE'])) . '">' . __('Datenschutzerklärung', 'hellotrust') . '</a> | <a href="' . esc_attr($this->checkStringTranslated($this->options['general']['link_imprint_' . $this->current_language], $this->options['general']['link_imprint_de_DE'])) . '">' . __('Impressum', 'hellotrust') . '</a><br/>
                    ' . (($this->options['general']['hide_row_version_and_info']) ? '' : '<a href="https://hellotrust.de" id="hellotrust_popup_external_link" target="_blank">' . __('hellotrust.de - Cookie Management', 'hellotrust') . ' - v.' . HT_PLUGIN_VERSION . ' - ' . $this->current_language . '</a>') . '
                </div>
            </div>
        </div>';
        $output .= '<div id="hellotrust_btn_trigger_cookie_popup" class="' . (($this->options['general']['fixed_link_cookie_popup_icon_or_text']) ? '' : 'hellotrust_btn_trigger_cookie_popup__icon_set') . ' ' . /*( ($this->isCookiesAccepted()) ? '' : 'hellotrust_btn_trigger_cookie_popup__hide' ).*/ '" ' . (($this->options['general']['highlight_color']) ? ' style="color:' . $this->options['general']['highlight_text_color'] . '; background:' . $this->options['general']['highlight_color'] . '" ' : '') . '>';
        if ($this->options['general']['fixed_link_cookie_popup_icon_or_text']) {
            $output .= __('Datenschutzeinstellungen', 'hellotrust') . ' &raquo;';
        } else {
            $output .= '<img src="' . plugins_url('assets/fingerprint_white.svg', __FILE__) . '" class="hellotrust_cookie_popup_icon" />';
        }
        $output .= '</div>';

        echo apply_filters('hellotrust_cookie_output', $output);
    }

    // Funktion liefert Frontendscripte zurück
    function ajax_cookies_accept()
    {
        /*
        $cookies = ($_POST['cookies']);
        $cats = ($_POST['cats']);
        setcookie("hellotrust_cookies_accepted", $cookies, time()+62208000, '/', $_SERVER['HTTP_HOST']);
        setcookie("hellotrust_categories_accepted", $cats, time()+62208000, '/', $_SERVER['HTTP_HOST']);

        $msg = "";
        $cookies = explode(",", $cookies);
        foreach($cookies as $cookie) {
            $obj = $this->getCookieByID($cookie);
            $msg = ''.$obj->name.', '.$msg;
        }
        $this->addClientHistory(__('Popup erfolgreich bestätigt mit Cookies:', 'hellotrust').' '.$msg);

        // statistiken
        // categories
        $stats_categories = get_option('hellotrust_stats_categories');
        $year = date("Y");
        $month = date("m");
        if(isset($cats) && is_array($cats)) {
	        foreach($cats as $cat) {
	            if($stats_categories["$year-$month"]) {
	                $curr = $stats_categories["$year-$month"];
	            } else {
	                $curr = $stats_categories["$year-$month"];
	                $curr[$cat] = 1;
	            }
	            if($curr[$cat]) {
	                $curr[$cat]+1;
	            } else {
	                $curr[$cat] = 1;
	            }
	        }
        }

        update_option('hellotrust_stats', $stats_categories);
        */

        //print_r($_POST['cookies']);

        $cookies = ($_POST['cookies']);
        $cookies = explode(",", $cookies);

        // Filtert die notwendigen Cookies heraus, da diese bereits im HTML eingebettet sind
        $new_cookies = array_diff(array_map('intval', $cookies), array_map('intval', $this->getEssentialCookies()));

        echo $this->getFrontendScripts($new_cookies);
        die();
    }

    function ajax_get_history()
    {
        $cookies = ($_POST['cookies']);

        $msg = "";
        $cookies = explode(",", $cookies);

        foreach ($cookies as $cookie) {
            $obj = $this->getCookieByID($cookie);
            $msg = '' . $obj->name . ', ' . $msg;
        }

        $new_msg = date("d.m.Y - H:i", current_time('timestamp')) . ' ' . __('Uhr', 'hellotrust') . ' - ' . __('Popup erfolgreich bestätigt mit Cookies:', 'hellotrust') . ' ' . $msg . '<br>';

        // Cookie muss von Javascript gesetzt werden
        // Ungefähr so:
        // //setcookie("hellotrust_history", $new_msg . " " . $old_history, time()+62208000, '/');
        // Alte Historie muss erhalten bleiben, diese Funktion hier liefert nur die neue Historie!
        echo $new_msg;
        die();
    }
}
