<?php
include_once "api/hellotrust_api.php";
include_once "updater.php";

// ------
// ACF

// Define path and URL to the ACF plugin.
define( 'HELLOTRUST_ACF_PATH', plugin_dir_path(__FILE__) . 'acf/' );
define( 'HELLOTRUST_ACF_URL', plugin_dir_url(__FILE__) . 'acf/' );

if( ! class_exists('ACF') ) {
    // Include the ACF plugin.
    include_once( HELLOTRUST_ACF_PATH . 'acf.php' );

    // Customize the url setting to fix incorrect asset URLs.
    add_filter('acf/settings/url', 'hellotrust_acf_settings_url');
    function hellotrust_acf_settings_url( $url ) {
        return HELLOTRUST_ACF_URL;
    }

    // (Optional) Hide the ACF admin menu item.
    add_filter('acf/settings/show_admin', 'hellotrust_acf_settings_show_admin');
    function hellotrust_acf_settings_show_admin( $show_admin ) {
        return false;
    }

    function custom_acf_settings_textdomain($domain) {
        return 'hellotrust';
    }

    add_filter('acf/settings/l10n_textdomain', 'custom_acf_settings_textdomain');
}

if( function_exists('acf_add_local_field_group') ):

    acf_add_local_field_group(array(
        'key' => 'group_5d2c58d216388',
        'title' => 'helloTrust - Cookie-Kategorie',
        'fields' => array(
            array(
                'key' => 'field_hoh9g8hfdd70ec93fb0',
                'label' => __('Name (Deutsch)', 'hellotrust'),
                'name' => 'name_de_DE',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_gg5345dd70ec93fb0',
                'label' => __('Name (Englisch)', 'hellotrust'),
                'name' => 'name_en_US',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_f84kfd70dhec93fb0',
                'label' => __('Name (Niederländisch)', 'hellotrust'),
                'name' => 'name_nl_NL',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_frf84kfd70dhec93fb0',
                'label' => __('Name (Französisch)', 'hellotrust'),
                'name' => 'name_fr_FR',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_itf84kfd70dhec93fb0',
                'label' => __('Name (Italienisch)', 'hellotrust'),
                'name' => 'name_it_IT',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_esf84kfd70dhec93fb0',
                'label' => __('Name (Spanisch)', 'hellotrust'),
                'name' => 'name_es_ES',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                  ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_ruff8a784kfd70dhec93fb0',
                'label' => __('Name (Russisch)', 'hellotrust'),
                'name' => 'name_ru_RU',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_sf7hgh60ec93fbf945jgm0',
                'label' => __('Beschreibung (Deutsch)', 'hellotrust'),
                'name' => 'description_de_DE',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_0ec93fbf945jgm0',
                'label' => __('Beschreibung (Englisch)', 'hellotrust'),
                'name' => 'description_en_US',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_j5lg8d8fec93fbf945jgm0',
                'label' => __('Beschreibung (Niederländisch)', 'hellotrust'),
                'name' => 'description_nl_NL',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_frj5lg8d8fec93fbf945jgm0',
                'label' => __('Beschreibung (Französisch)', 'hellotrust'),
                'name' => 'description_fr_FR',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_itj5lg8d8fec93fbf945jgm0',
                'label' => __('Beschreibung (Italienisch)', 'hellotrust'),
                'name' => 'description_it_IT',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_esj5lg8d8fec93fbf945jgm0',
                'label' => __('Beschreibung (Spanisch)', 'hellotrust'),
                'name' => 'description_es_ES',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_esm0s87fajfmajaru',
                'label' => __('Beschreibung (Russisch)', 'hellotrust'),
                'name' => 'description_ru_RU',
                'type' => 'textarea',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_5d2c5937c62c7',
                'label' => __('Priorität', 'hellotrust'),
                'name' => 'prio',
                'type' => 'number',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'prepend' => '',
                'append' => '',
                'min' => '',
                'max' => '',
                'step' => '',
            ),
            array(
                'key' => 'field_5d70ec93fb0c9',
                'label' => __('Cookies sind nicht abwählbar', 'hellotrust'),
                'name' => 'hellotrust_locked',
                'type' => 'true_false',
                'instructions' => __('Die Cookies dieser Kategorie sind zwingend notwendig, daher nicht abwählbar.', 'hellotrust'),
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => 0,
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
        ),
        'location' => array(
            array(
                array(
                    'param' => 'taxonomy',
                    'operator' => '==',
                    'value' => 'hellotrust-cookies-category',
                ),
            ),
        ),
        'menu_order' => 0,
        'position' => 'normal',
        'style' => 'default',
        'label_placement' => 'top',
        'instruction_placement' => 'label',
        'hide_on_screen' => array(
            0 => 'permalink',
            1 => 'the_content',
            2 => 'excerpt',
            3 => 'discussion',
            4 => 'comments',
            5 => 'revisions',
            6 => 'slug',
            7 => 'author',
            8 => 'format',
            9 => 'page_attributes',
            10 => 'featured_image',
            11 => 'categories',
            12 => 'tags',
            13 => 'send-trackbacks',
        ),
        'active' => true,
        'description' => '',
    ));

    acf_add_local_field_group(array(
        'key' => 'group_5d2c5871e0799',
        'title' => 'helloTrust - Cookies',
        'fields' => array(
            array(
                'key' => 'field_5d2c5896fc22f',
                'label' => __('Quellcode', 'hellotrust'),
                'name' => 'code',
                'type' => 'textarea',
                'instructions' => __('Hier Script-Codes mit Angabe des <script>-Tags einfügen', 'hellotrust'),
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_5dfdfugd4a9d6681726',
                'label' => __('Name (Deutsch)', 'hellotrust'),
                'name' => 'name_de_DE',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_gkgzszdzg72hsf6',
                'label' => __('Name (Englisch)', 'hellotrust'),
                'name' => 'name_en_EN',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_lf7h6fsdfis7jh',
                'label' => __('Name (Niederländisch)', 'hellotrust'),
                'name' => 'name_nl_NL',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_fggh5gkgzszdzg72hsf6',
                'label' => __('Name (Französisch)', 'hellotrust'),
                'name' => 'name_fr_FR',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_2hsf6dfug7s7',
                'label' => __('Name (Spanisch)', 'hellotrust'),
                'name' => 'name_es_ES',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_ru2hsf6dfug7s7',
                'label' => __('Name (Russisch)', 'hellotrust'),
                'name' => 'name_ru_RU',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_fsdg42hsf6dfug7s7',
                'label' => __('Name (Italienisch)', 'hellotrust'),
                'name' => 'name_it_IT',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_5d4a9d6681726',
                'label' => __('Zweck (Deutsch)', 'hellotrust'),
                'name' => 'description_de_DE',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_asdfasdf5d91d50edb807',
                'label' => __('Zweck (Englisch)', 'hellotrust'),
                'name' => 'description_en_US',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_5d91d50edb807',
                'label' => __('Zweck (Niederländisch)', 'hellotrust'),
                'name' => 'description_nl_NL',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_fr5d91d50edb807',
                'label' => __('Zweck (Französisch)', 'hellotrust'),
                'name' => 'description_fr_FR',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_it5d91d50edb807',
                'label' => __('Zweck (Italienisch)', 'hellotrust'),
                'name' => 'description_it_IT',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_es5d91d50edb807',
                'label' => __('Zweck (Spanisch)', 'hellotrust'),
                'name' => 'description_es_ES',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_ru5d91d50edb80gs7',
                'label' => __('Zweck (Russisch)', 'hellotrust'),
                'name' => 'description_ru_RU',
                'type' => 'textarea',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'maxlength' => '',
                'rows' => '',
                'new_lines' => '',
            ),
            array(
                'key' => 'field_5d4a9d7c81727',
                'label' => __('Verfallsdauer (Deutsch)', 'hellotrust'),
                'name' => 'expiration_de_DE',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'prepend' => '',
                'append' => '',
                'maxlength' => '',
            ),
            array(
                'key' => 'field_enex5345dd70ec93fb0',
                'label' => __('Verfallsdauer (Englisch)', 'hellotrust'),
                'name' => 'expiration_en_EN',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_enexf84kfd70dhec93fb0',
                'label' => __('Verfallsdauer (Niederländisch)', 'hellotrust'),
                'name' => 'expiration_nl_NL',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_frex84kfd70dhec93fb0',
                'label' => __('Verfallsdauer (Französisch)', 'hellotrust'),
                'name' => 'expiration_fr_FR',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_itexf84kfd70dhec93fb0',
                'label' => __('Verfallsdauer (Italienisch)', 'hellotrust'),
                'name' => 'expiration_it_IT',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_esexf84kfd70dhec93fb0',
                'label' => __('Verfallsdauer (Spanisch)', 'hellotrust'),
                'name' => 'expiration_es_ES',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_ruexff8a784kfd70dhec93fb0',
                'label' => __('Verfallsdauer (Russisch)', 'hellotrust'),
                'name' => 'expiration_ru_RU',
                'type' => 'text',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => "",
                'ui' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
            ),
            array(
                'key' => 'field_5db9b7f50104e',
                'label' => __('Anbieter', 'hellotrust'),
                'name' => 'vendor',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => '',
                'prepend' => '',
                'append' => '',
                'maxlength' => '',
            ),
            array(
                'key' => 'field_5db9b7fb0104f',
                'label' => __('Anbieter Link zur Datenschutzerklärung', 'hellotrust'),
                'name' => 'vendor_privacy_policy',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => 'https://',
                'prepend' => '',
                'append' => '',
                'maxlength' => '',
            ),
            array(
                'key' => 'field_5db9b80801050',
                'label' => __('Anbieter Link für Opt Out', 'hellotrust'),
                'name' => 'vendor_opt_out',
                'type' => 'text',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'default_value' => '',
                'placeholder' => 'https://',
                'prepend' => '',
                'append' => '',
                'maxlength' => '',
            ),
        ),
        'location' => array(
            array(
                array(
                    'param' => 'post_type',
                    'operator' => '==',
                    'value' => 'hellotrust-cookies',
                ),
            ),
        ),
        'menu_order' => 0,
        'position' => 'normal',
        'style' => 'default',
        'label_placement' => 'top',
        'instruction_placement' => 'label',
        'hide_on_screen' => array(
            0 => 'permalink',
            1 => 'the_content',
            2 => 'excerpt',
            3 => 'discussion',
            4 => 'comments',
            5 => 'revisions',
            6 => 'slug',
            7 => 'author',
            8 => 'format',
            9 => 'page_attributes',
            10 => 'featured_image',
            11 => 'categories',
            12 => 'tags',
            13 => 'send-trackbacks',
        ),
        'active' => true,
        'description' => '',
    ));

endif;